from pybricks import ev3brick as brick
from pybricks.ev3devices import (Motor, TouchSensor, ColorSensor,
                                 InfraredSensor, UltrasonicSensor, GyroSensor)
from pybricks.parameters import (Port, Stop, Direction, Button, Color,
                                 SoundFile, ImageFile, Align)
from pybricks.tools import print, wait, StopWatch
from pybricks.robotics import DriveBase
import threading
import math

cl = StopWatch()
c = cl.time()

left_motor = Motor(Port.C, Direction.COUNTERCLOCKWISE)
right_motor = Motor(Port.B, Direction.CLOCKWISE)

capture = Motor(Port.D, Direction.COUNTERCLOCKWISE)
Slift = Motor(Port.A, Direction.CLOCKWISE)

left_d = ColorSensor(Port.S2)
right_d = ColorSensor(Port.S1)

ultro = UltrasonicSensor(Port.S4)
ultro_r = UltrasonicSensor(Port.S3)

stop_r = right_motor.stop(Stop.BRAKE)
stop_l = left_motor.stop(Stop.BRAKE) 

wheeld = 81.6
track = 175
robot = DriveBase(left_motor, right_motor, wheeld, track)

class up():
    def __init__(self, v, target_angle):
        self.v = v
        self.target_angle = target_angle
    
    def on(self):
        capture.reset_angle(0)
        capture.run_target(self.v, self.target_angle, Stop.HOLD, True)

    def off(self):
        capture.reset_angle(0)
        capture.run_target(-1*(self.v), -1*(self.target_angle), Stop.HOLD, True)
class lift():
    def __init__(self, v):
        self.v = v
    
    def on(self, target_angle):
        Slift.reset_angle(0)
        Slift.run_target(self.v, target_angle, Stop.HOLD, True)

    def off(self, target_angle):
        Slift.reset_angle(0)
        Slift.run_target(-1*(self.v), -1*(target_angle), Stop.HOLD, True)
class linia():
    def __init__(self, v, kp, ki, kd):
        self.v = v
        self.kp = float(kp)
        self.ki = float(ki)
        self.kd = float(kd)
    def pid(self, reflect_blac_r1, reflect_blac_r2):
        last_error = 0
        integral = 0
        different = 0
        r1 = right_d.reflection()
        r2 = left_d.reflection()
        while (r1 > reflect_blac_r1) or (r2 > reflect_blac_r2):
            r1 = right_d.reflection()
            r2 = left_d.reflection()
            error = r2 - r1
            p = error*self.kp
            integral += error
            i = integral*self.ki
            d = (error - last_error)*self.kd
            corr = p + i + d
            speed2 = (-1*corr) + self.v
            speed1 = corr + self.v
            left_motor.run(speed1)
            right_motor.run(speed2)
            last_error =  error 
        stop_r
        stop_l
    def pid_inc(self, g):
        last_error = 0
        integral = 0
        different = 0
        r1 = right_d.reflection()
        r2 = left_d.reflection()
        c = right_motor.angle()
        while (g > c):
            c = right_motor.angle()
            r1 = right_d.reflection()
            r2 = left_d.reflection()
            error = r2 - r1
            p = error*self.kp
            integral += error
            i = integral*self.ki
            d = (error - last_error)*self.kd
            corr = p + i + d
            speed2 = (-1*corr) + self.v
            speed1 = corr + self.v
            left_motor.run(speed1)
            right_motor.run(speed2)
            last_error =  error 
        stop_r
        stop_l
    def vr(self):
        r1 = right_d.reflection()
        r2 = left_d.reflection()
        while (cl.time() - c) < 2000: 
            r1 = right_d.reflection()
            r2 = left_d.reflection()
            error = r2 - r1
            p = error*10000
            speed2 = (-1*p)
            speed1 = p
            left_motor.run(speed1)
            right_motor.run(speed2)
        stop_r
        stop_l
    def gr(self, v, gradus):
        if (gradus < 0):
            v = -1*v
            gradus = -1*gradus
        g = track*gradus/wheeld
        right_motor.reset_angle(0)
        c = right_motor.angle()
        math.fabs(c)
        while (g > c):
            c = right_motor.angle()
            if c < 0:
                c = -1*c
            math.fabs(c)
            right_motor.run(v)
            v1 = -1*(v)
            left_motor.run(v1)
    def proezd(self, sm):
        s = (sm*360)/(math.pi*wheeld)
        right_motor.reset_angle(0)
        left_motor.reset_angle(0)
        l = left_motor.angle()
        r = left_motor.angle() 
        while ((s > l) and (s > r)):
            l = left_motor.angle()
            r = left_motor.angle()
            left_motor.run(self.v)
            right_motor.run(self.v)
    def inv_proezd(self, sm):
        s = (sm*360)/(math.pi*wheeld)
        right_motor.reset_angle(0)
        left_motor.reset_angle(0)
        l = left_motor.angle()
        r = left_motor.angle() 
        v1 = -1*(self.v)
        while ((s > l) and (s > r)):
            l = -1*(left_motor.angle())
            r = -1*(left_motor.angle())
            left_motor.run(v1)
            right_motor.run(v1)
class inversion():
    def __init__(self, v, kp, ki, kd):
        self.v = v
        self.kp = float(kp)
        self.ki = float(ki)
        self.kd = float(kd)
    def pid_right(self, reflect_blac_r1):
        last_error = 0
        integral = 0
        different = 0
        r1 = right_d.reflection()
        r2 = left_d.reflection()
        while (r1 > reflect_blac_r1):
            r1 = right_d.reflection()
            r2 = left_d.reflection()
            error = r2 - r1
            p = error*self.kp
            integral += error
            i = integral*self.ki
            d = (error - last_error)*self.kd
            corr = p + i + d
            speed2 = (-1*corr) + self.v
            speed1 = corr + self.v
            left_motor.run(speed1)
            right_motor.run(speed2)
            last_error =  error 
        right_motor.stop(Stop.BRAKE)
        left_motor.stop(Stop.BRAKE) 
    def pid_left(self, reflect_blac_r2):
        last_error = 0
        integral = 0
        different = 0
        r1 = right_d.reflection()
        r2 = left_d.reflection()
        while (r2 > reflect_blac_r2):
            r1 = right_d.reflection()
            r2 = left_d.reflection()
            error = r2 - r1
            p = error*self.kp
            integral += error
            i = integral*self.ki
            d = (error - last_error)*self.kd
            corr = p + i + d
            speed2 = (-1*corr) + self.v
            speed1 = corr + self.v
            left_motor.run(speed1)
            right_motor.run(speed2)
            last_error =  error 
        right_motor.stop(Stop.BRAKE)
        left_motor.stop(Stop.BRAKE) 
    def inv_pid_right(self, reflect_white_r1):
        last_error = 0
        integral = 0
        different = 0
        r1 = right_d.reflection()
        r2 = left_d.reflection()
        while (r1 < reflect_white_r1):
            r1 = right_d.reflection()
            r2 = left_d.reflection()
            error = -1*(r2 - r1)
            p = error*self.kp
            integral += error
            i = integral*self.ki
            d = (error - last_error)*self.kd
            corr = p + i + d
            speed2 = (-1*corr) + self.v
            speed1 = corr + self.v
            left_motor.run(speed1)
            right_motor.run(speed2)
            last_error =  error 
        right_motor.stop(Stop.BRAKE)
        left_motor.stop(Stop.BRAKE) 
    def inv_pid_left(self, reflect_white_r2):
        last_error = 0
        integral = 0
        different = 0
        r1 = right_d.reflection()
        r2 = left_d.reflection()
        while (r2 < reflect_white_r2):
            r1 = right_d.reflection()
            r2 = left_d.reflection()
            error = -1*(r2 - r1)
            p = error*self.kp
            integral += error
            i = integral*self.ki
            d = (error - last_error)*self.kd
            corr = p + i + d
            speed2 = (-1*corr) + self.v
            speed1 = corr + self.v
            left_motor.run(speed1)
            right_motor.run(speed2)
            last_error =  error 
        right_motor.stop(Stop.BRAKE)
        left_motor.stop(Stop.BRAKE) 
class cegelring():
    def __init__(self, v):
        self.v = v
    def do_linii(self, v, reflect_blac):
        r1 = right_d.reflection()
        while (r1 > reflect_blac):
            r1 = right_d.reflection()
            left_motor.run(v)
            right_motor.run(v)
        stop_r
        stop_l
    def proezd(self, sm):
        s = (sm*360)/(math.pi*wheeld)
        right_motor.reset_angle(0)
        left_motor.reset_angle(  0)
        l = left_motor.angle()
        r = left_motor.angle() 
        while ((s > l) and (s > r)):
            l = left_motor.angle()
            r = left_motor.angle()
            left_motor.run(self.v)
            right_motor.run(self.v)
        s = -1*(s+(50*360)/(math.pi*wheeld))
        right_motor.reset_angle(0)
        left_motor.reset_angle(0)
        l = left_motor.angle()
        r = left_motor.angle()
        while ((s < l) and (s < r)):
            l = left_motor.angle()
            r = left_motor.angle()
            left_motor.run(-200)
            right_motor.run(-200)
class lab():
    def __init__(self, v, kp, kd):
        self.v = v
        self.kp = float(kp)
        self.kd = float(kd)
    def reg(self, sm):
        last_error = 0
        different = 0
        r2 = ultro_r.distance(False)
        r1 = sm
        while (ultro_r.distance(False) < 95) and (ultro.distance(False) > 130):
            r2 = ultro_r.distance(False)
            r1 = sm
            error = r2 - r1
            p = error*self.kp
            d = (error - last_error)*self.kd
            corr = p + d
            speed2 = (-1*corr) + self.v
            speed1 = corr + self.v
            left_motor.run(speed1)
            right_motor.run(speed2)
            last_error =  error 
        right_motor.stop(Stop.BRAKE)
        left_motor.stop(Stop.BRAKE) 
        
maze = lab(250, 3.6, 2.8)  #3.7, 2.8)
line = linia(400, 7, 0.01, 5)
ceg = cegelring(500) 
line_inv = inversion(250, 2.8, 0.1, 10)
lf = lift(200)
UP = up(500, 100)
i = 0

if brick.battery.voltage() > 7990:

    line.pid_inc(2400)
    line.gr(200, 70)
    ceg.do_linii(-100, 40)
    line.vr()
    line.proezd(400)
    line.gr(200, -70)
    line.proezd(670)
    line.gr(200, -70)
    ceg.do_linii(300, 18)
    line.proezd(60)
    ceg.do_linii(300, 18)
    line.proezd(10)
    line.gr(200, 70)
    line.pid(18, 18) 
    right_motor.stop(Stop.BRAKE)
    left_motor.stop(Stop.BRAKE) 
    wait(4500) 

    line_inv.pid_left(18)
    print('^')
    line_inv.inv_pid_left(40)
    print('>')
    line_inv.pid_left(10)
    print('^')
    line_inv.inv_pid_left(35)
    print('^') 
    line_inv.pid_left(18)
    print('^')
    line_inv.inv_pid_right(35)
    print('<')
    line_inv.pid_right(18)
    print('<')
    line_inv.inv_pid_right(35)
    print('^')
    line_inv.pid_right(18)
    print('^')
    line_inv.inv_pid_right(35)
    print('^')
    line_inv.pid_left(18)#
    print('>')
    line_inv.inv_pid_left(38)
    print('>')
    line_inv.pid_left(18)
    print('^')
    line_inv.inv_pid_right(35)
    print('<')
    line_inv.pid_left(18)
    print('^')

    line.proezd(70)
    ceg.do_linii(300, 15)
    line.gr(200, 46)
    line.proezd(380)
    line.gr(200, -17)
    for i in range(3):
        ceg.do_linii(300, 15)
        line.proezd(200)
        line.inv_proezd(200)
        line.gr(200, -85)
    ceg.do_linii(300, 15)
    line.proezd(200)
    line.inv_proezd(200)
    line.gr(200, 32)
    line.vr()
    line.inv_proezd(350)
    right_motor.stop(Stop.BRAKE)
    left_motor.stop(Stop.BRAKE) 
    lf.on(170)
    line.inv_proezd(90)
    right_motor.stop(Stop.BRAKE)
    left_motor.stop(Stop.BRAKE) 
    lf.on(60)
    UP.on()

    wait(4000) 
    line.proezd(10)
    line_inv.pid_left(18)
    line_inv.inv_pid_left(35)

    line_inv.pid_left(18)
    line_inv.inv_pid_right(39)

    line_inv.pid_right(18)
    line_inv.inv_pid_left(40)

    line_inv.pid_right(18)
    line_inv.inv_pid_left(38)

    line_inv.pid_left(18)
    line_inv.inv_pid_left(39)

    line_inv.pid_right(18)
    line_inv.inv_pid_right(38)

    line_inv.pid_right(18)
    line_inv.inv_pid_right(38)

    line_inv.pid_right(18)

    right_motor.stop(Stop.BRAKE)
    left_motor.stop(Stop.BRAKE) 

    right_motor.stop(Stop.BRAKE)
    left_motor.stop(Stop.BRAKE)  

    wait(4500) 

    line.proezd(50)
    line.pid_inc(1700)
    line.gr(200, -70)

    ceg.do_linii(-100, 40)
    line.vr()
    line.proezd(360)
    line.gr(200, 70)
    line.proezd(590)
    line.gr(200, 80)
    ceg.do_linii(300, 15)
    line.proezd(60)
    ceg.do_linii(300, 15)
    line.proezd(10)
    line.gr(200, -70)
    line.pid(12, 12)
    right_motor.stop(Stop.BRAKE)
    left_motor.stop(Stop.BRAKE) 

    wait(10000) 

    while True:
        maze.reg(60)
        if (ultro.distance(False) < 330) and (ultro_r.distance(False) > 90):
            while (ultro.distance(False) > 140):
                left_motor.run(200)
                right_motor.run(200) 
            line.gr(200, -70)
            line.proezd(125)
            print('1')
        if (ultro.distance(False) < 150) and (ultro_r.distance(False) < 110):
            line.gr(200, 70)
            print('2')
        if (ultro.distance(False) > 450) and (ultro_r.distance(False) > 80):
            line.proezd(130)
            line.gr(200, -70)
            line.proezd(130)
            print('3')